//
// ======== SoundOutput.java ========
//
// generated by GenModule.java
//
 
/**
 * This module plays au files when its boolean input stream is on.
 * It only plays the sound once each time the stream goes on.  The stream
 * must go off, then on again for the sound to play again.
 *
 * @version    1.0, Sat Apr 13 11:57:19  1996
 * @author     Johannes N. Johannsen, jojo@well.com
 */
import java.applet.*;
public class SoundOutput extends OutputDevice {
 
   /**
    * Streams access by user names below, or vectors declared in NeatToolsModule.
    */
   NeatInputStream soundFile;
   NeatInputStream playSound;
 
   /**
    * Non-stream custom fields.
    */
   AudioClip sound;
   SoundThread runner;
 
 
   /**
    * Constructor for SoundOutput
    */
   public SoundOutput() {
      super();
      soundFile = new FixedStringStream( "" );
      inputStreams.addElement( soundFile );
      playSound = new NeatInputStream( IOstream.BOOLEAN );
      inputStreams.addElement( playSound );
 
      // non-stream constructor initializations...
      runner = new SoundThread( );
   }
 
 
   /**
    * Generated function update*
    */
   public void update() {
      if ( playSound.isTrue() ) {
	System.out.println( "Playsound stream is true." );
         if ( !runner.isAlive() ) {
	System.out.println( "Runner is not alive..." );
            runner.setSound( sound );
	System.out.println( "Starting runner.." );
            runner.start();
 	try {
			Thread.sleep( 10000 );
		} catch ( java.lang.InterruptedException e ) {
		}        }
		 else
	System.out.println( "runner is alive.." );
      }
	  else System.out.println( "Playsound stream is false.." );
   }
 
 
   /**
    * Generated function startUp*
    */
   public void startUp() {
      sound = NeatToolsApplication.application.getAudioClip( 
            NeatToolsApplication.application.getCodeBase(),
            soundFile.getString() + ".au" );
      
      
   }
 
 
   /**
    * Generated function shutDown*
    */
   public void shutDown() {
      if ( runner.isAlive() ) {
         runner.stop();
      }
   }
}
